package userdbclient;

import javax.swing.table.*;

import userdb.*;

/**
 * <p>Title: Client for Unix-User-Database-Administration</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: HPI Potsdam</p>
 * @author Michael Dirska
 * @version 1.0
 */

public class MyTableModel extends AbstractTableModel {

  ShortInfo list[];

  public MyTableModel() {
    list = new ShortInfo[0];
  }

  public void loadList(ShortInfo[] newList)
  {
    list = newList;
  }

  public int getColumnCount()
  {
    return 2;
  }

  public Object getValueAt(int row, int col) {
    String s;

    if (col == 0)
    {
        s = list[row].name;
    }
    else
    {
        if (list[row].status.equals(UnixUserStatus.NEW))
        {
          s = "NEW";
        }
        else if (list[row].status.equals(UnixUserStatus.READY))
        {
          s = "READY";
        }
        else if (list[row].status.equals(UnixUserStatus.DENY_ACCESS))
        {
          s = "DENY_ACCESS";
        }
        else
        {
          s = "DELETED";
        }
    }

    return new String(s);
  }

  public int getRowCount() {

    return list.length;
  }

  public UnixUser getUnixUserAt(int i)
  {
    return list[i].theUser;
  }

  public boolean isUnixUserNewAt(int i)
  {
    return list[i].status.equals(UnixUserStatus.NEW);
  }

}