

import userdb.*;
import java.sql.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;



class UnixUserDefaultServant extends UnixUserServant
{
    java.util.LinkedList list;
    
    UnixUserDefaultServant (ORB orb, POA userdbPOA,
	 String dbUrl, String dbUser, String dbPassword)
    {
	super (orb, userdbPOA, dbUrl, dbUser, dbPassword, null);

	list = new java.util.LinkedList();
    }

    void checkState()
    {
      state = null;

      try
      {
	UnixUserServant.State s = new UnixUserServant.State();

	byte oid[] = _object_id();

	for (int i=0; i < oid.length; i++)
	{
	    if (
    "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ+/=".
		    indexOf( oid[i] ) < 0)
	    {
		throw new org.omg.CORBA.INV_OBJREF("oid has invalid chars");
	    }
	}

	s.sid = new String (oid);

	Connection db = DriverManager.getConnection(dbUrl, dbUser, dbPassword);

	Statement stmt = db.createStatement();

	ResultSet rs = stmt.executeQuery(
	 "SELECT login, name, uid, gid, homedir, status FROM USERIDS " +
	   "WHERE sid='" + s.sid + "'");

	if (rs.next() == false)
	{
	    throw new org.omg.CORBA.INV_OBJREF("sid not found");
	}


	s.login = rs.getString("login");
	s.name = rs.getString("name");
	s.uid = rs.getInt("uid");
	s.gid = rs.getInt("gid");
	s.homedir = rs.getString("homedir");

	int stat = rs.getInt("status");

	rs.close();
	stmt.close();
	db.close();

	switch(stat)
	{
	    case 1:
		s.status = UnixUserStatus.NEW;
		break;
	    case 9:
		s.status = UnixUserStatus.DENY_ACCESS;
		break;
	    case 10:
		s.status = UnixUserStatus.READY;
		break;
	    default:
		s.status = UnixUserStatus.DELETED;
		break;
	}

	state = s;


	UnixUserServant usrv = new UnixUserServant(orb, userdbPOA, db, state);

	UnixUser u = UnixUserHelper.narrow(
	    userdbPOA.create_reference_with_id( state.sid.getBytes(),
		"IDL:userdb/UnixUser:1.0"));

	userdbPOA.activate_object_with_id( state.sid.getBytes(), usrv);

	System.out.println("activating Servant for "+state.login);

	list.addLast(usrv);

	if (list.size() > 10)
	{
	    usrv = (UnixUserServant) list.getFirst();
	    
	    userdbPOA.deactivate_object( usrv.state.sid.getBytes());	

	    System.out.println("deactivating Servant for "+usrv.state.login);

	    list.removeFirst();
	}

      }
      catch (Exception e)
      {
	    e.printStackTrace();
	    throw new org.omg.CORBA.UNKNOWN();
      }
    }
}

